# Axis Group Jogging URCap Example
## Description
The Axis Group Jogging URCap provides a working example for jogging the first axis in a given axis group via control presented in the toolbar.
## Build
* The URCap SDK must be installed and available in the build environment
1.
   ```bash
   cd axis-group-jogging
   ```
1.
   ```bash
   ./build.sh
   ```
   Note: By default the build script will attempt to build the URCap then deploy to a local simulator (if available).
## Usage
* Note: The Axis Group Jogging URCap does not manage the lifecycle of any world-model or axis-group entities.
1. On the robot, execute a program or script that creates an Axis Group and Axis
   * The program/script should finish without removing the Axis Group.
   * Example script:
     ```ruby
     POSITIONER_AXIS_TYPE = 0 # 0:revolute, 1:prismatic
     POSITIONER_VELOCITY_LIMIT = d2r(360) # rad/s
     POSITIONER_ACCELERATION_LIMIT = d2r(3600) # rad/s^2
     POSITIONER_ENCODER_RESOLUTION = 3600 # counts/rev
     POSITIONER_FEED_CONSTANT = d2r(360) # rad/rev
     POSITIONER_GEAR_RATIO = 1.0
     POSITIONER_ZERO_OFFSET = 0

     reset_world_model()
     axis_group_add("positioner", p[0, 0, 0, 0, 0, 0], "world")
     axis_group_add_axis("positioner", "axis1", "", p[0, 0, 0, 0, 0, 0], 
     POSITIONER_AXIS_TYPE, POSITIONER_VELOCITY_LIMIT, POSITIONER_ACCELERATION_LIMIT)
     ```
1. After the program has finished executing, open the Axis Jog panel of the toolbar

   ![open toolbar](./docs/images/open_toolbar.png)
1. Enter the indicated parameters specific to the desired Axis Group to jog

   ![toolbar parameters](./docs/images/toolbar_parameters.png)
1. Jog the first Axis of the given Axis Group by holding down either the `<-` or `->` button
   * The grey indicator icon will change to green and the `Sent Command` field will update to indicate the command that has been sent to the robot via the Primary Interface
   
   ![activate jogging](./docs/images/activate_jogging.png)
1. Halt jogging by releasing the held-down button
   * The green indicator icon will change to grey and the `Sent Command` field will update to indicate the command that has been sent to the robot via the Primary Interface
   
   ![deactivate jogging](./docs/images/deactivate_jogging.png)
* Notes:
  1. While the toolbar is open, the `actual_external_q` and `target_external_q` fields will reflect the RTDE registers of the same names
  1. If operating without external axis hardware (e.g. Ethercat URCap and servo), only the `target_external_q` value will change
