package com.ur.urcap.externalaxis.coordinatedmotionprogrammer.impl;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.BorderLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import com.ur.urcap.api.contribution.ContributionProvider;
import com.ur.urcap.api.contribution.ViewAPIProvider;
import com.ur.urcap.api.contribution.program.swing.SwingProgramNodeView;
import com.ur.urcap.api.domain.userinteraction.keyboard.KeyboardTextInput;
import com.ur.urcap.api.domain.userinteraction.keyboard.KeyboardInputFactory;
import com.ur.urcap.api.domain.userinteraction.keyboard.KeyboardNumberInput;

// This contains the implementation for the MovePWithAxisGroup program node.
// Most of the implementation details are found in the parent class.
public
class MovePWithAxisGroupNodeView extends BaseMoveWithAxisGroupNodeView
    implements SwingProgramNodeView<MovePWithAxisGroupNodeContribution> {
 private
  final Style style;

 public
  MovePWithAxisGroupNodeView(ViewAPIProvider apiProvider, final Style style) {
    super(style, apiProvider.getUserInterfaceAPI()
                     .getUserInteraction()
                     .getKeyboardInputFactory());

    this.style = style;
  }

  @Override public void buildUI(
      JPanel panel,
      final ContributionProvider<MovePWithAxisGroupNodeContribution> provider) {
    panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));

    panel.add(createAxisInputControls(provider));

    panel.add(createVerticalSpacing(style.getExtraLargeVerticalSpacing()));

    panel.add(createRobotInputControls(provider));

    panel.add(createVerticalSpacing(style.getExtraLargeVerticalSpacing()));

    panel.add(createParameterInputControls(provider));
  }
}
