# EtherCAT Axis Config URCap Example
## Description
The EtherCAT Axis Config URCap provides a working example for configuring an axis via user input presented in the installation node.
## Build
* The URCap SDK must be installed and available in the build environment
1.
   ```bash
   cd ethercat-axis-config
   ```
1.
   ```bash
   ./build.sh
   ```
   Note: By default the build script will attempt to build the URCap then deploy to a local simulator (if available).
## Usage
* Note: The EtherCAT Axis Config URCap does not manage the lifecycle of any world-model or axis-group entities.

1. Go into the Installation tab in Polyscope and click on the EtherCAT Axis Config URCap.

   ![installation node](./docs/images/ethercat-axis-config-installation-node.png)
1. Changes made to the axis configuration will persist in the DataModel. Notice how a change in the Max Velocity adds an asterisk to the installation indicating that changes have been made.

   ![data persistence](./docs/images/ethercat-axis-config-installation-data-model-persistance.png)
1. Remember to save your changes when exiting Polyscope to ensure the persistence of your axis configuration.

   ![save installation](./docs/images/ethercat-axis-config-save-installation.png)