package com.ur.urcap.externalaxis.ethercataxisconfig.installationNode;

import com.ur.urcap.api.contribution.ViewAPIProvider;
import com.ur.urcap.api.contribution.installation.ContributionConfiguration;
import com.ur.urcap.api.contribution.installation.CreationContext;
import com.ur.urcap.api.contribution.installation.InstallationAPIProvider;
import com.ur.urcap.api.contribution.installation.swing.SwingInstallationNodeService;
import com.ur.urcap.api.domain.SystemAPI;
import com.ur.urcap.api.domain.data.DataModel;

import com.ur.urcap.externalaxis.ethercataxisconfig.impl.V5Style;
import com.ur.urcap.externalaxis.ethercataxisconfig.impl.Style;
import com.ur.urcap.externalaxis.ethercataxisconfig.impl.V3Style;

import java.util.Locale;

public class EtherCATAxisConfigInstallationNodeService implements SwingInstallationNodeService<EtherCATAxisConfigInstallationNodeContribution, EtherCATAxisConfigInstallationNodeView> {

	@Override
	public void configureContribution(ContributionConfiguration configuration) {
	}

	@Override
	public String getTitle(Locale locale) {
		return "EtherCAT Axis Config";
	}

	@Override
	public EtherCATAxisConfigInstallationNodeView createView(ViewAPIProvider apiProvider) {
		SystemAPI systemAPI = apiProvider.getSystemAPI();
		Style style = systemAPI.getSoftwareVersion().getMajorVersion() >= 5 ? new V5Style() : new V3Style();
		return new EtherCATAxisConfigInstallationNodeView(style);
	}

	@Override
	public EtherCATAxisConfigInstallationNodeContribution createInstallationNode(
			InstallationAPIProvider apiProvider,
			EtherCATAxisConfigInstallationNodeView view,
			DataModel model,
			CreationContext context) {
		return new EtherCATAxisConfigInstallationNodeContribution(apiProvider, view, model);
	}
}
