package com.ur.urcap.externalaxis.moveto.URCommunicator;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketTimeoutException;

public class ScriptReader implements Runnable {
    private String receivedString = "";
    private final Integer SOCKET_PORT = 12343; // socket for getting string waypoint data back from robot
    private final Integer TIMEOUT = 1000; // timeout for the socket

    @Override
    public void run() {
        try {
            ServerSocket server = new ServerSocket(SOCKET_PORT);

            // Set a timeout on the server socket so that it's cleaned up nicely
            // if an error occurs on the program running on the robot and
            // doesn't close the socket connection itself.
            server.setSoTimeout(TIMEOUT);

            Socket socket;
            try {
                socket = server.accept();
            } catch (SocketTimeoutException e) {
                server.close();
                throw e;
            }

            BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));

            receivedString = reader.readLine();

            reader.close();
            socket.close();
            server.close();
        } catch (IOException e) {
            System.err.println("Failed to read data from the robot.");
            receivedString = "";
        }
    }

    public String getReceivedString() {
        return receivedString;
    }
}