package com.ur.urcap.externalaxis.rotaryaxiscalibration.installationNode.installationNodeView;

import com.ur.urcap.api.contribution.installation.swing.SwingInstallationNodeView;
import com.ur.urcap.externalaxis.rotaryaxiscalibration.installationNode.installationNodeContribution.RotaryAxisCalibrationInstallationNodeContribution;

import javax.swing.*;

import com.ur.urcap.externalaxis.rotaryaxiscalibration.impl.Style;

import java.awt.*;

public class RotaryAxisCalibrationInstallationNodeView implements SwingInstallationNodeView<RotaryAxisCalibrationInstallationNodeContribution> {

	private final Style style;
	private final SamplePosePanel samplePosePanel;
	private final CalibrationResultPanel CalibrationResultPanel;

	public RotaryAxisCalibrationInstallationNodeView(Style style) {
		this.style = style;
		samplePosePanel = new SamplePosePanel(this);
		CalibrationResultPanel = new CalibrationResultPanel(this);
	}

	@Override
	public void buildUI(JPanel jPanel, final RotaryAxisCalibrationInstallationNodeContribution installationNode) {
		GridLayout gridLayout = new GridLayout(1, 2);
		jPanel.setLayout(gridLayout);

		jPanel.add(samplePosePanel);
		jPanel.add(CalibrationResultPanel);

	}

	public SamplePosePanel getSamplePosePanel() {
		return samplePosePanel;
	}

	public CalibrationResultPanel getCalibrationResultPanel() {
		return CalibrationResultPanel;
	}
}
